Public Class OneDayClass
    Private Shared configData As New ConfigDataClass

    Private m_Date As DateTime
    Private m_Memo As MemoDataClass
    Private m_DisplayMemoIcon As Boolean
    Private m_Rect As Rectangle
    Private m_LongScheduleRect As Rectangle
    Private m_Selected As Boolean
    Private m_ScheduleData As List(Of ScheduleDataClass)
    Private Shared dayFont As New Font("MS UI Gothic", 9)
    Private Shared memoFont As New Font("MS UI Gothic", 8)

    '̃IuWFNg̑ΏۂƂȂt
    Public Property DateOfThis() As DateTime
        Get
            Return m_Date
        End Get
        Set(ByVal value As DateTime)
            m_Date = value
        End Set
    End Property

    '
    Public Property Memo() As MemoDataClass
        Get
            Return m_Memo
        End Get
        Set(ByVal value As MemoDataClass)
            m_Memo = value
        End Set
    End Property

    'J_[Memo\Ă邩ǂ
    Public Property IsDisplayMemoIcon() As Boolean
        Get
            Return m_DisplayMemoIcon
        End Get
        Set(ByVal value As Boolean)
            m_DisplayMemoIcon = value
        End Set
    End Property

    '̓t̂PJ_[̈ʒuATCY
    Public Property Rect() As Rectangle
        Get
            Return m_Rect
        End Get
        Set(ByVal value As Rectangle)
            m_Rect = value
        End Set
    End Property

    '̓t̂QJ_[̈ʒuATCY
    Public Property LongScheduleRect() As Rectangle
        Get
            Return m_LongScheduleRect
        End Get
        Set(ByVal value As Rectangle)
            m_LongScheduleRect = value
        End Set
    End Property

    'IĂ邩ǂ
    Public Property Selected() As Boolean
        Get
            Return m_Selected
        End Get
        Set(ByVal value As Boolean)
            m_Selected = value
        End Set
    End Property

    '̓t̃XPW[
    Public Property ScheduleData() As List(Of ScheduleDataClass)
        Get
            Return m_ScheduleData
        End Get
        Set(ByVal value As List(Of ScheduleDataClass))
            m_ScheduleData = value
        End Set
    End Property

    ''' <summary>
    ''' RXgN^
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub New()
        m_Date = Nothing
        m_Memo = New MemoDataClass
        m_DisplayMemoIcon = False
        m_Rect = Nothing
        m_LongScheduleRect = Nothing
        m_Selected = False
        m_ScheduleData = New List(Of ScheduleDataClass)

    End Sub

    ''' <summary>
    ''' RXgN^
    ''' </summary>
    ''' <param name="newdate"></param>
    ''' <param name="setting"></param>
    ''' <remarks></remarks>
    Public Sub New(ByVal newdate As DateTime, ByVal setting As ConfigDataClass)
        m_Date = newdate
        m_Memo = New MemoDataClass
        m_DisplayMemoIcon = False
        m_Rect = Nothing
        m_LongScheduleRect = Nothing
        m_Selected = False
        m_ScheduleData = New List(Of ScheduleDataClass)
        configData = setting

    End Sub

    ''' <summary>
    ''' ̓t̑I`̈ʒuATCYԂ
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetSelectRect() As Rectangle
        Return New Rectangle(m_Rect.X + 1, m_Rect.Y + 1, m_Rect.Width - 2, m_Rect.Height - 2)

    End Function

    ''' <summary>
    ''' J_[ɓt\ʒuATCYԂ
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetDayTextRect() As Rectangle
        Return New Rectangle(m_Rect.X + 2, m_Rect.Y + 2, m_Rect.Width - 3, m_Rect.Height - 3)

    End Function

    ''' <summary>
    ''' QJ_[ɃXPW[\ʒuATCYԂ
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetLongScheduleDayTextRect() As Rectangle
        Return New Rectangle(m_LongScheduleRect.X + 0, m_LongScheduleRect.Y + 2, m_LongScheduleRect.Width - 0, m_LongScheduleRect.Height - 0)

    End Function

    ''' <summary>
    ''' PJ_[ɃXPW[\ʒuATCYԂ
    ''' </summary>
    ''' <param name="count"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetScheduleTextRect(ByVal count As Integer) As Rectangle
        Dim scFont As New Font("MS UI Gothic", configData.FontSizeSchedule)

        Return New Rectangle(m_Rect.X + 3, m_Rect.Y + dayFont.Height + 1 + scFont.Height + (count - 1) * (scFont.Height + 1), _
                    m_Rect.Width - 4, scFont.Height)

    End Function

    ''' <summary>
    ''' PJ_[łPƂ̎lpg`
    ''' </summary>
    ''' <param name="gr"></param>
    ''' <param name="br"></param>
    ''' <param name="printMode"></param>
    ''' <remarks></remarks>
    Public Sub DrawBox(ByVal gr As Graphics, ByVal br As System.Drawing.Brush, ByVal printMode As Boolean)
        If printMode Then
            gr.DrawRectangle(Pens.Black, Rect)
        Else
            gr.FillRectangle(br, Rect)
            gr.DrawRectangle(Pens.DarkGray, Rect)
        End If
    End Sub

    ''' <summary>
    ''' tƃ̕`
    ''' </summary>
    ''' <param name="gr"></param>
    ''' <param name="br"></param>
    ''' <param name="printMode"></param>
    ''' <remarks></remarks>
    Public Sub DrawDayText(ByVal gr As Graphics, ByVal br As System.Drawing.Brush, ByVal printMode As Boolean)
        Dim sf As New StringFormat()
        sf.Alignment = StringAlignment.Far

        If printMode Then
            gr.DrawString(DateOfThis.Day.ToString, dayFont, br, GetDayTextRect)
        Else
            gr.DrawString(DateOfThis.Day.ToString, dayFont, br, GetDayTextRect)
            If Memo.Text <> "" Then
                gr.DrawString("Memo", memoFont, Brushes.Gray, GetDayTextRect, sf)
            Else
            End If
        End If

        sf.Dispose()
    End Sub

    ''' <summary>
    ''' PƂ̑Ig̕`
    ''' </summary>
    ''' <param name="gr"></param>
    ''' <remarks></remarks>
    Public Sub DrawSelectedBox(ByVal gr As Graphics)
        If Selected.Equals(True) Then
            gr.DrawRectangle(Pens.DarkGreen, GetSelectRect())
        End If

    End Sub

    ''' <summary>
    ''' XPW[̕`
    ''' </summary>
    ''' <param name="gr"></param>
    ''' <param name="br"></param>
    ''' <param name="printMode"></param>
    ''' <remarks></remarks>
    Public Sub DrawSchedules(ByVal gr As Graphics, ByVal br As System.Drawing.Brush, ByVal printMode As Boolean)
        Dim count As Integer = 0
        Dim rect, rectCircle As Rectangle
        Dim scFont As New Font("MS UI Gothic", configData.FontSizeSchedule)

        Dim brushOneDayScheduleF As New SolidBrush(Color.FromArgb(configData.ColorOneDayScheduleFore))
        Dim brushOneDayScheduleSF As New SolidBrush(Color.FromArgb(configData.ColorOneDayScheduleSelectFore))
        Dim brushOneDayScheduleSB As New SolidBrush(Color.FromArgb(configData.ColorOneDayScheduleSelectBack))
        Dim brushMultiDaysScheduleF As New SolidBrush(Color.FromArgb(configData.ColorMultiDaysScheduleFore))
        Dim brushMultiDaysScheduleB As New SolidBrush(Color.FromArgb(configData.ColorMultiDaysScheduleBack))
        Dim brushMultiDaysScheduleSF As New SolidBrush(Color.FromArgb(configData.ColorMultiDaysScheduleSelectFore))
        Dim brushMultiDaysScheduleSB As New SolidBrush(Color.FromArgb(configData.ColorMultiDaysScheduleSelectBack))

        For Each scheduleData As ScheduleDataClass In m_ScheduleData

            'o͈ʒuw肳Ăꍇ
            If scheduleData.RowNum > 0 Then
                count = scheduleData.RowNum
            End If

            'gȂ\
            If (GetScheduleTextRect(count).Bottom < GetSelectRect.Bottom - 1) And scheduleData.IsValid Then
                If scheduleData.StartDateTime.Date = scheduleData.EndDateTime.Date Then
                    '1ɂ܂XPW[
                    scheduleData.Rect = GetScheduleTextRect(count)

                    If scheduleData.BaseSchedule.Selected Then
                        'I
                        gr.FillRectangle(brushOneDayScheduleSB, scheduleData.Rect)
                        gr.DrawString(scheduleData.Title, scFont, brushOneDayScheduleSF, GetScheduleTextRect(count))
                    Else
                        'I
                        gr.DrawString(scheduleData.Title, scFont, brushOneDayScheduleF, GetScheduleTextRect(count))
                    End If

                Else
                    'ɂ܂XPW[
                    If m_Date = scheduleData.StartDateTime.Date Then
                        '̏ꍇ
                        rect = GetScheduleTextRect(count)
                        rect.X -= 3
                        rect.Width += 5
                        scheduleData.Rect = rect

                        rectCircle = rect
                        rectCircle.Width = rectCircle.Height * 3 / 4
                        rect.Width -= rect.Height * 3 / 8
                        rect.X += rect.Height * 3 / 8

                        If scheduleData.BaseSchedule.Selected Then
                            'I
                            gr.FillEllipse(brushMultiDaysScheduleSB, rectCircle)
                            gr.FillRectangle(brushMultiDaysScheduleSB, rect)
                            gr.DrawString(scheduleData.Title, scFont, brushMultiDaysScheduleSF, GetScheduleTextRect(count))
                        Else
                            'I
                            gr.FillEllipse(brushMultiDaysScheduleB, rectCircle)
                            gr.FillRectangle(brushMultiDaysScheduleB, rect)
                            gr.DrawString(scheduleData.Title, scFont, brushMultiDaysScheduleF, GetScheduleTextRect(count))
                        End If


                    ElseIf m_Date = scheduleData.EndDateTime.Date Then
                        'ŏȈꍇ
                        rect = GetScheduleTextRect(count)
                        rect.X -= 3
                        rect.Width += 4
                        scheduleData.Rect = rect

                        rectCircle = rect
                        rectCircle.Width = rectCircle.Height * 3 / 4
                        rectCircle.X += rect.Width - rect.Height * 3 / 4
                        rect.Width -= rect.Height * 3 / 8

                        If scheduleData.BaseSchedule.Selected Then
                            'I
                            gr.FillEllipse(brushMultiDaysScheduleSB, rectCircle)
                            gr.FillRectangle(brushMultiDaysScheduleSB, rect)

                            'T͂߂̏ꍇ \
                            If (m_Date.DayOfWeek = DayOfWeek.Sunday) Then
                                gr.DrawString(scheduleData.Title, scFont, brushMultiDaysScheduleSF, GetScheduleTextRect(count))
                            End If
                        Else
                            'I
                            gr.FillEllipse(brushMultiDaysScheduleB, rectCircle)
                            gr.FillRectangle(brushMultiDaysScheduleB, rect)

                            'T͂߂̏ꍇ \
                            If (m_Date.DayOfWeek = DayOfWeek.Sunday) Then
                                gr.DrawString(scheduleData.Title, scFont, brushMultiDaysScheduleF, GetScheduleTextRect(count))
                            End If
                        End If

                    Else
                        'ԓ̏ꍇ
                        rect = GetScheduleTextRect(count)
                        rect.X -= 3
                        rect.Width += 6
                        scheduleData.Rect = rect

                        If scheduleData.BaseSchedule.Selected Then
                            'I
                            gr.FillRectangle(brushMultiDaysScheduleSB, rect)

                            'T͂߂̏ꍇ \
                            If (m_Date.DayOfWeek = DayOfWeek.Sunday) Then
                                gr.DrawString(scheduleData.Title, scFont, brushMultiDaysScheduleSF, GetScheduleTextRect(count))
                            End If
                        Else
                            'I
                            gr.FillRectangle(brushMultiDaysScheduleB, rect)

                            'T͂߂̏ꍇ \
                            If (m_Date.DayOfWeek = DayOfWeek.Sunday) Then
                                gr.DrawString(scheduleData.Title, scFont, brushMultiDaysScheduleF, GetScheduleTextRect(count))
                            End If
                        End If

                    End If
                End If
                count += 1
            End If
        Next
    End Sub

    ''' <summary>
    ''' P̍\vf܂Ƃ߂ĕ`
    ''' </summary>
    ''' <param name="gr"></param>
    ''' <param name="brText"></param>
    ''' <param name="brBackground"></param>
    ''' <param name="left"></param>
    ''' <param name="top"></param>
    ''' <param name="width"></param>
    ''' <param name="height"></param>
    ''' <param name="printMode"></param>
    ''' <remarks></remarks>
    Public Sub DrawOneDayAllParts(ByVal gr As Graphics, ByVal brText As System.Drawing.Brush, ByVal brBackground As System.Drawing.Brush, _
                    ByVal left As Integer, ByVal top As Integer, ByVal width As Integer, ByVal height As Integer, Optional ByVal printMode As Boolean = False)
        m_Rect = New Rectangle(left, top, width, height)
        DrawBox(gr, brBackground, printMode)
        DrawDayText(gr, brText, printMode)
        DrawSchedules(gr, brText, printMode)

        If Not printMode Then
            DrawSelectedBox(gr)
        End If

    End Sub

    ''' <summary>
    ''' XPW[̃NA
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub ClearSchedules()
        Dim dummySchedule As New ScheduleDataClass

        dummySchedule.IsValid = False
        dummySchedule.RowNum = -1

        '擪̓_~[
        m_ScheduleData.Clear()
        m_ScheduleData.Add(dummySchedule)

    End Sub


    ''' <summary>
    ''' XPW[̓o^
    ''' </summary>
    ''' <param name="scheduleData">o^XPW[</param>
    ''' <param name="rowNum">PJ_[ł̏c\ʒu</param>
    ''' <param name="rowNumLong">QJ_[ł̏c\ʒu</param>
    ''' <param name="registRowNumLong">QJ_[ł̏c\ʒuo^邩ǂ</param>
    ''' <remarks></remarks>
    Public Sub RegisterSchedules(ByRef scheduleData As ScheduleDataClass, ByRef rowNum As Integer, ByRef rowNumLong As Integer, Optional ByVal registRowNumLong As Boolean = False)
        'ɂ܂XPW[o^
        If scheduleData.IsValid And scheduleData.IsMultiDays() And _
                    (((m_Date.Date >= scheduleData.StartDateTime.Date) And _
                    (m_Date.Date <= scheduleData.EndDateTime.Date))) Then


            'f[^ǉ
            m_ScheduleData.Add(New ScheduleDataClass(scheduleData))
            m_ScheduleData(m_ScheduleData.Count - 1).BaseSchedule = scheduleData.BaseSchedule

            'łΏo͏ꏊisjo
            If m_Date.Date.Equals(scheduleData.StartDateTime.Date) Then
                'o^XPW[̈ÕXPW[ʒu{P
                rowNum = m_ScheduleData(m_ScheduleData.Count - 1 - 1).RowNum + 1
                rowNumLong = m_ScheduleData(m_ScheduleData.Count - 1 - 1).RowNumLong + 1
            End If

            'T͂߂łΏo͏ꏊisjo
            If m_Date.DayOfWeek = DayOfWeek.Sunday Then
                'o^XPW[̈ÕXPW[ʒu(+1)
                rowNum = m_ScheduleData(m_ScheduleData.Count - 1 - 1).RowNum + 1
            End If

            '̏ł΁AXPW[o
            If registRowNumLong Then
                rowNumLong = m_ScheduleData(m_ScheduleData.Count - 1 - 1).RowNumLong + 1
            End If

            'o͏ꏊ̐ݒiȊÓAo͏ꏊƓsɂj
            m_ScheduleData(m_ScheduleData.Count - 1).RowNum = rowNum
            m_ScheduleData(m_ScheduleData.Count - 1).RowNumLong = rowNumLong


            'P̃XPW[
        ElseIf scheduleData.IsValid And Not scheduleData.IsMultiDays() And _
                    (m_Date.Date.Equals(scheduleData.StartDateTime.Date)) Then
            'f[^ǉ
            m_ScheduleData.Add(New ScheduleDataClass(scheduleData))
            m_ScheduleData(m_ScheduleData.Count - 1).BaseSchedule = scheduleData.BaseSchedule

            'o^XPW[̈ÕXPW[ʒu{P
            rowNum = m_ScheduleData(m_ScheduleData.Count - 1 - 1).RowNum + 1
            m_ScheduleData(m_ScheduleData.Count - 1).RowNum = rowNum

        End If
    End Sub

    ''' <summary>
    ''' NbNW̃`FbNƓt̑IiJ_[j
    ''' </summary>
    ''' <param name="mouseX"></param>
    ''' <param name="mouseY"></param>
    ''' <param name="redrawPanel"></param>
    ''' <param name="forceSelect"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Function CheckSelectDate(ByVal mouseX As Integer, ByVal mouseY As Integer, ByRef redrawPanel As Panel, Optional ByVal forceSelect As Boolean = False) As Boolean
        '܂őIĂt
        If m_Selected Then
            m_Selected = False
            redrawPanel.Invalidate(m_Rect)
        End If

        'NbNt
        If m_Rect.Contains(mouseX, mouseY) Or forceSelect Then
            m_Selected = True
            redrawPanel.Invalidate(m_Rect)
        Else
            m_Selected = False
        End If

        CheckSelectDate = m_Selected 'return

    End Function

    ''' <summary>
    ''' NbNW̃`FbNƃXPW[̑IiJ_[j
    ''' </summary>
    ''' <param name="mouseX"></param>
    ''' <param name="mouseY"></param>
    ''' <param name="redrawPanel"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Function CheckSelectSchedule(ByVal mouseX As Integer, ByVal mouseY As Integer, ByRef redrawPanel As Panel) As Boolean

        Dim bufSelecated As Boolean = False

        For Each scheduleData As ScheduleDataClass In m_ScheduleData
            If scheduleData.IsValid Then
                'I
                If scheduleData.Rect.Contains(mouseX, mouseY) Then
                    scheduleData.BaseSchedule.Selected = True
                    bufSelecated = True
                End If

            End If
        Next

        'return
        CheckSelectSchedule = bufSelecated
    End Function


    ''' <summary>
    ''' XPW[Iꂽꍇ̍ĕ`
    ''' </summary>
    ''' <param name="redrawPanel"></param>
    ''' <remarks></remarks>
    Public Sub InvalidateScheduleArea(ByRef redrawPanel As Panel)

        For Each scheduleData As ScheduleDataClass In m_ScheduleData
            If scheduleData.IsValid Then
                'IĂ΍ĕ`
                If scheduleData.BaseSchedule.Selected Then
                    If scheduleData.Rect <> Nothing Then
                        redrawPanel.Invalidate(scheduleData.Rect)
                    End If
                End If

                'O܂őIĂ̂ĕ`
                If scheduleData.BaseSchedule.Redraw Then
                    If scheduleData.Rect <> Nothing Then
                        redrawPanel.Invalidate(scheduleData.Rect)
                    End If
                End If
            End If
        Next

    End Sub


    ''' <summary>
    ''' QXPW[ɂĂP̍\vf܂Ƃ߂ĕ`
    ''' </summary>
    ''' <param name="gr"></param>
    ''' <param name="ft"></param>
    ''' <param name="brText"></param>
    ''' <param name="brBackDate"></param>
    ''' <param name="brBackYoubi"></param>
    ''' <param name="brBackSchedule"></param>
    ''' <param name="left"></param>
    ''' <param name="top"></param>
    ''' <param name="width"></param>
    ''' <param name="height"></param>
    ''' <param name="panelHeight"></param>
    ''' <param name="forceDrawTitile"></param>
    ''' <remarks></remarks>
    Public Sub DrawLongScheduleParts(ByVal gr As Graphics, ByRef ft As Font, ByVal brText As System.Drawing.Brush, _
                    ByVal brBackDate As System.Drawing.Brush, ByVal brBackYoubi As System.Drawing.Brush, ByVal brBackSchedule As System.Drawing.Brush, _
                    ByVal left As Integer, ByVal top As Integer, ByVal width As Integer, ByVal height As Integer, _
                    ByVal panelHeight As Integer, Optional ByVal forceDrawTitile As Boolean = False)

        Dim youbiStr() As String = {"", "", "", "", "", "", "y"}
        Dim y As Integer
        Dim sf As New StringFormat()
        Dim count As Integer = 0
        Dim rect, rectCircle As Rectangle

        Dim brushMultiDaysScheduleF As New SolidBrush(Color.FromArgb(configData.ColorMultiDaysScheduleFore))
        Dim brushMultiDaysScheduleB As New SolidBrush(Color.FromArgb(configData.ColorMultiDaysScheduleBack))


        sf.Alignment = StringAlignment.Center
        m_LongScheduleRect = New Rectangle(left, top, width, height * 15)

        'lp
        For y = 0 To CInt(panelHeight / height)
            gr.DrawRectangle(Pens.LightGray, New Rectangle(left, top + y * height, width, height))
            'hԂ
            If y > 1 Then
                gr.FillRectangle(brBackSchedule, New Rectangle(left + 1, top + y * height + 1, width - 1, height - 1))
            End If
        Next

        'ɂ --
        y = 0
        'hԂ
        gr.FillRectangle(brBackDate, New Rectangle(left + 1, top + y * height + 1, width - 1, height - 1))

        't`
        If (DateOfThis.Day = 1) Then
            gr.DrawString(DateOfThis.Month.ToString & "/" & DateOfThis.Day.ToString, ft, brText, New Rectangle(left, top + y * height + 3, width, height), sf)
        Else
            gr.DrawString(DateOfThis.Day.ToString, ft, brText, New Rectangle(left, top + y * height + 3, width, height), sf)
        End If

        'j --
        y = 1
        'hԂ
        gr.FillRectangle(brBackYoubi, New Rectangle(left + 1, top + y * height + 1, width - 1, height - 1))
        'j`
        gr.DrawString(youbiStr(DateOfThis.DayOfWeek), ft, brText, New Rectangle(left, top + y * height + 3, width, height), sf)

        'XPW[
        For Each scheduleData As ScheduleDataClass In m_ScheduleData

            'o͈ʒuw肳Ăꍇ
            If scheduleData.RowNumLong > 0 Then
                count = scheduleData.RowNumLong
            Else
                count = 1
            End If

            'gȂ\
            If scheduleData.IsValid And scheduleData.IsMultiDays Then
                'ɂ܂XPW[
                If m_Date = scheduleData.StartDateTime.Date Then
                    '̏ꍇ
                    rect = New Rectangle(left, top + (count + 1) * height, width + 1, height)

                    rectCircle = rect
                    rectCircle.Width = rectCircle.Height * 3 / 4
                    rect.Width -= rect.Height * 3 / 8
                    rect.X += rect.Height * 3 / 8
                    gr.FillEllipse(brushMultiDaysScheduleB, rectCircle)
                    gr.FillRectangle(brushMultiDaysScheduleB, rect)

                    rect.Width = width * ((scheduleData.EndDateTime.Date - scheduleData.StartDateTime.Date).Days + 1)
                    rect.Y += 2
                    gr.DrawString(scheduleData.Title, ft, brushMultiDaysScheduleF, rect)

                ElseIf m_Date = scheduleData.EndDateTime.Date Then
                    'ŏȈꍇ
                    rect = New Rectangle(left, top + (count + 1) * height, width, height)

                    rectCircle = rect
                    rectCircle.Width = rectCircle.Height * 3 / 4
                    rectCircle.X += rect.Width - rect.Height * 3 / 4
                    rect.Width -= rect.Height * 3 / 8

                    gr.FillEllipse(brushMultiDaysScheduleB, rectCircle)
                    gr.FillRectangle(brushMultiDaysScheduleB, rect)

                ElseIf forceDrawTitile Then
                    rect = New Rectangle(left, top + (count + 1) * height, width + 1, height)
                    gr.FillRectangle(brushMultiDaysScheduleB, rect)
                    rect.Width = width * ((scheduleData.EndDateTime.Date - scheduleData.StartDateTime.Date).Days + 1)
                    rect.Y += 2
                    gr.DrawString(scheduleData.Title, ft, brushMultiDaysScheduleF, rect)

                Else
                    'ȊȌꍇ
                    rect = New Rectangle(left, top + (count + 1) * height, width + 1, height)
                    gr.FillRectangle(brushMultiDaysScheduleB, rect)
                End If
                count += 1
            End If
        Next

        sf.Dispose()

    End Sub

    ''' <summary>
    ''' Xgr[ɂ̗̓\\
    ''' </summary>
    ''' <param name="lv"></param>
    ''' <param name="schedulesAdded"></param>
    ''' <remarks></remarks>
    Public Sub WriteDaySchedulesToListView(ByRef lv As ListView, ByRef schedulesAdded As List(Of ScheduleDataClass))
        Dim item As ListViewItem

        schedulesAdded.Clear()
        lv.Items.Clear()

        For Each scheduleData As ScheduleDataClass In m_ScheduleData
            If scheduleData.IsValid Then
                item = lv.Items.Add(scheduleData.StartDateTime.ToString("M/d HH:mm"))
                item.SubItems.Add(scheduleData.EndDateTime.ToString("M/d HH:mm"))
                item.SubItems.Add(scheduleData.Title)
                item.SubItems.Add(scheduleData.Place)

                schedulesAdded.Add(scheduleData.BaseSchedule)
            End If
        Next
    End Sub

End Class
