Public Class ScheduleDataClass
    Implements IComparable

    Private m_startDateTime As DateTime  'JnƎ
    Private m_endDateTime As DateTime  'IƎ
    Private m_inputDateTime As DateTime '͂
    Private m_title As String  'XPW[
    Private m_place As String  'ꏊ
    Private m_memo As String  'L
    Private m_rowNum As Integer 'o͂ʒu
    Private m_rowNumLong As Integer 'o͂ʒu
    Private m_rect As Rectangle '`W

    Private m_repeatStartDate As DateTime  'JԂꍇ̓o^Jn
    Private m_repeatEndDate As DateTime  'JԂꍇ̓o^I
    Private m_repeatType As RepeatTypePattern  'JԂ̎
    Private m_validData As Boolean  '̃XPW[Lǂ
    Private m_selected As Boolean 'IĂ邩ǂ
    Private m_redraw As Boolean 'ĕ`

    Private m_baseSchedule As ScheduleDataClass 'ɂƂɓWJꍇAWJO̊ɂXPW[

    Public m_font As Font  'tHg

    'JԂp^[
    Public Enum RepeatTypePattern
        None
        daily
        weekly
        monthly
    End Enum


    'JnƎ
    Public Property StartDateTime() As DateTime
        Get
            Return m_startDateTime
        End Get
        Set(ByVal value As DateTime)
            m_startDateTime = value
        End Set
    End Property

    'IƎ
    Public Property EndDateTime() As DateTime
        Get
            Return m_endDateTime
        End Get
        Set(ByVal value As DateTime)
            m_endDateTime = value
        End Set
    End Property

    '͂
    Public Property InputDateTime() As DateTime
        Get
            Return m_inputDateTime
        End Get
        Set(ByVal value As DateTime)
            m_inputDateTime = value
        End Set
    End Property

    'XPW[
    Public Property Title() As String
        Get
            Return m_title
        End Get
        Set(ByVal value As String)
            m_title = value
        End Set
    End Property

    'ꏊ
    Public Property Place() As String
        Get
            Return m_place
        End Get
        Set(ByVal value As String)
            m_place = value
        End Set
    End Property

    'L
    Public Property Memo() As String
        Get
            Return m_memo
        End Get
        Set(ByVal value As String)
            m_memo = value
        End Set
    End Property

    'o͂ʒu
    Public Property RowNum() As Integer
        Get
            Return m_rowNum
        End Get
        Set(ByVal value As Integer)
            m_rowNum = value
        End Set
    End Property

    'o͂ʒuiQXPW[j
    Public Property RowNumLong() As Integer
        Get
            Return m_rowNumLong
        End Get
        Set(ByVal value As Integer)
            m_rowNumLong = value
        End Set
    End Property

    '`W
    Public Property Rect() As Rectangle
        Get
            Return m_rect
        End Get
        Set(ByVal value As Rectangle)
            m_rect = value
        End Set
    End Property

    'JԂꍇ̓o^Jn
    Public Property RepeatStartDateTime() As DateTime
        Get
            Return m_repeatStartDate
        End Get
        Set(ByVal value As DateTime)
            m_repeatStartDate = value
        End Set
    End Property

    'JԂꍇ̓o^I
    Public Property RepeatEndDateTime() As DateTime
        Get
            Return m_repeatEndDate
        End Get
        Set(ByVal value As DateTime)
            m_repeatEndDate = value
        End Set
    End Property

    'JԂ̎
    Public Property RepeatType() As RepeatTypePattern
        Get
            Return m_repeatType
        End Get
        Set(ByVal value As RepeatTypePattern)
            m_repeatType = value
        End Set
    End Property

    '̃XPW[Lǂ
    Public Property Valid() As Boolean
        Get
            Return m_validData
        End Get
        Set(ByVal value As Boolean)
            m_validData = value
        End Set
    End Property

    '̃XPW[Lǂ
    Public Property IsValid() As Boolean
        Get
            Return m_validData
        End Get
        Set(ByVal value As Boolean)
            m_validData = value
        End Set
    End Property

    'IĂ邩ǂ
    Public Property Selected() As Boolean
        Get
            Return m_selected
        End Get
        Set(ByVal value As Boolean)
            m_selected = value
        End Set
    End Property

    'ĕ`
    Public Property Redraw() As Boolean
        Get
            Return m_redraw
        End Get
        Set(ByVal value As Boolean)
            m_redraw = value
        End Set
    End Property

    'ɂƂɓWJꍇAWJO̊ɂXPW[
    Public Property BaseSchedule() As ScheduleDataClass
        Get
            Return m_baseSchedule
        End Get
        Set(ByVal value As ScheduleDataClass)
            m_baseSchedule = value
        End Set
    End Property

    'ɂ܂XPW[ǂ
    Public Function IsMultiDays()
        If m_startDateTime.Date.Equals(m_endDateTime.Date) Then
            IsMultiDays = False
        Else
            IsMultiDays = True
        End If

    End Function

    'tHg
    Public Property Font() As Font
        Get
            Return m_font
        End Get
        Set(ByVal value As Font)
            m_font = value
        End Set
    End Property

    ''' <summary>
    ''' RXgN^
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub New()
        m_startDateTime = Nothing
        m_endDateTime = Nothing
        m_inputDateTime = Nothing
        m_title = ""
        m_place = ""
        m_memo = ""
        m_rowNum = 0
        m_rowNumLong = 0
        m_rect = Nothing

        m_repeatStartDate = Nothing
        m_repeatEndDate = Nothing
        m_repeatType = RepeatTypePattern.None
        m_validData = True
        m_selected = False
        m_redraw = False
        m_font = Nothing

        m_baseSchedule = Nothing
    End Sub

    ''' <summary>
    ''' RXgN^
    ''' </summary>
    ''' <param name="sd_from"></param>
    ''' <remarks></remarks>
    Public Sub New(ByVal sd_from As ScheduleDataClass)
        m_startDateTime = sd_from.m_startDateTime
        m_endDateTime = sd_from.m_endDateTime
        m_inputDateTime = sd_from.m_inputDateTime
        m_title = sd_from.m_title
        m_place = sd_from.m_place
        m_memo = sd_from.m_memo
        m_rowNum = sd_from.m_rowNum
        m_rowNumLong = sd_from.m_rowNumLong
        m_rect = sd_from.m_rect

        m_repeatStartDate = sd_from.m_repeatStartDate
        m_repeatEndDate = sd_from.m_repeatEndDate
        m_repeatType = sd_from.m_repeatType
        m_validData = sd_from.m_validData
        m_selected = sd_from.m_selected
        m_redraw = sd_from.m_redraw

        m_font = sd_from.m_font
        m_baseSchedule = sd_from.m_baseSchedule
    End Sub

    ''' <summary>
    ''' փRs[
    ''' </summary>
    ''' <param name="sd_from"></param>
    ''' <remarks></remarks>
    Public Sub Copy(ByVal sd_from As ScheduleDataClass)
        m_startDateTime = sd_from.m_startDateTime
        m_endDateTime = sd_from.m_endDateTime
        m_inputDateTime = sd_from.m_inputDateTime
        m_title = sd_from.m_title
        m_place = sd_from.m_place
        m_memo = sd_from.m_memo
        m_rowNum = sd_from.m_rowNum
        m_rowNumLong = sd_from.m_rowNumLong
        m_rect = sd_from.m_rect

        m_repeatStartDate = sd_from.m_repeatStartDate
        m_repeatEndDate = sd_from.m_repeatEndDate
        m_repeatType = sd_from.m_repeatType
        m_validData = sd_from.m_validData
        m_selected = sd_from.m_selected
        m_redraw = sd_from.m_redraw

        m_font = sd_from.m_font
        m_baseSchedule = sd_from.m_baseSchedule

    End Sub

    ''' <summary>
    ''' \[ĝ߂̃\bh
    ''' </summary>
    ''' <param name="obj"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overloads Function CompareTo(ByVal obj As Object) As Integer _
        Implements IComparable.CompareTo

        If TypeOf obj Is ScheduleDataClass Then
            Dim temp As ScheduleDataClass = CType(obj, ScheduleDataClass)
            Dim ret As Integer

            'JnŃ\[gr
            ret = m_startDateTime.CompareTo(temp.m_startDateTime)

            '̃XPW[ǂ ̂P
            If ret = 0 Then
                If temp.IsMultiDays() And (Not IsMultiDays()) Then
                    ret = 1
                End If
            End If

            '̃XPW[ǂ ̂Q
            If ret = 0 Then
                If IsMultiDays() And (Not temp.IsMultiDays()) Then
                    ret = -1
                End If
            End If

            '͂D
            If ret = 0 Then
                ret = m_inputDateTime.CompareTo(temp.m_inputDateTime)
            End If
            Return ret
        End If

        Return 0
    End Function
End Class


